Attribute VB_Name = "mMain"
' * Programmer Name  : Martijn
' * E-Mail           : bambi@crackdealer.com
' * Date             : 07-06-2001
' * Project Name     : IAF
' * Module Name      : mMain
' **********************************************************************
' * Comments         :
' *
' * This is just a 'working demo'.
' *
' **********************************************************************

Option Explicit

Dim arrGrid() As Boolean
Dim arrPower() As Long

Function fcnFindMessage(picDestination As PictureBox, _
  lngBits As Long, _
  blnRed As Boolean, _
  blnGreen As Boolean, _
  blnBlue As Boolean, _
  lngTrailingBits As Long) As String

  '***  This is the main function to find messages

  On Error GoTo ERROR_fcnFindMessage

  picDestination.ScaleMode = vbPixels

  Dim lngColorsUsed As Long
  Dim lngBitsAvailable As Long
  Dim lngCount As Long
  Dim lngX As Long
  Dim lngY As Long
  Dim lngWidth As Long
  Dim lngHeight As Long
  Dim lngBitCount As Long

  '***  store the powers of 2 in an array
  
  ReDim arrPower(0& To 30&) As Long
  For lngCount = 0& To 30&
    arrPower(lngCount) = 2& ^ lngCount
  Next

  '***  calculate the number of bits for message storing
  lngColorsUsed = Abs(blnRed + blnGreen + blnBlue)
  lngBitsAvailable = (picDestination.ScaleWidth) * (picDestination.ScaleHeight) * lngColorsUsed * (lngBits + 1&)

  ReDim arrGrid(0 To lngBitsAvailable)
  lngBitCount = 0&

  '***  read all the pixels.
  '***  keep the 'message bits' in an array

  With picDestination
    lngWidth = .ScaleWidth - 1&
    lngHeight = .ScaleHeight - 1&

    For lngX = 0& To lngWidth
      For lngY = 0& To lngHeight
        subAddToMessageGrid .Point(lngX, lngY), lngBits, blnRed, blnGreen, blnBlue, lngTrailingBits, lngBitCount
      Next
    Next
  End With

  '***  read the 'message bits' and get a string back

  fcnFindMessage = fcnGetGridText(lngBitsAvailable)

EXIT_fcnFindMessage:
  Exit Function

ERROR_fcnFindMessage:
  Select Case MsgBox("Error " & Err.Number & ": " & Err.Description & vbCrLf & "in fcnFindMessage" & vbCrLf & "The error occured at line: " & Erl, vbAbortRetryIgnore + vbCritical, "Error")
    Case vbAbort
      Screen.MousePointer = vbDefault
      Resume EXIT_fcnFindMessage
    Case vbRetry
      Resume
    Case vbIgnore
      Resume Next
  End Select

  Resume EXIT_fcnFindMessage

End Function

Function fcnGetChangedColor(lngColor As Long, _
  lngBits As Long, _
  blnRed As Boolean, _
  blnGreen As Boolean, _
  blnBlue As Boolean, _
  lngBitCount As Long) As Long
  
  '***  this function combines an existing pixel and a
  '***  few bits from the message
  '***  it returns the modified color
  
  Dim lngNewColor As Long
  Dim lngColorCount As Long
  Dim lngCount As Long
  Dim arrDoCol(0 To 2) As Boolean

  arrDoCol(2) = blnRed
  arrDoCol(1) = blnGreen
  arrDoCol(0) = blnBlue

  lngNewColor = lngColor

  For lngColorCount = 0& To 16& Step 8&
    If arrDoCol(lngColorCount \ 8&) Then
      For lngCount = lngColorCount To lngColorCount + lngBits
        If lngNewColor And arrPower(lngCount) Then
          lngNewColor = lngNewColor - arrPower(lngCount)
        End If
        If fcnGetNextBit(lngBitCount) Then
          lngNewColor = lngNewColor + arrPower(lngCount)
        End If
      Next
    End If
  Next

  fcnGetChangedColor = lngNewColor
End Function

Function fcnGetGridText(lngBitsAvailable As Long) As String
  Dim lngByteCount As Long
  Dim lngByteBitCount As Long
  Dim lngGridCount As Long
  Dim arrMessage() As Byte

  '***  read the bits from arrgrid()
  '***  puts the bits into an array of bytes

  ReDim arrMessage(0& To Int(lngBitsAvailable / 8&) - 1&)

  lngGridCount = 0&
  For lngByteCount = 0& To UBound(arrMessage, 1&)
    For lngByteBitCount = 0& To 7&
      arrMessage(lngByteCount) = arrMessage(lngByteCount) Or (arrGrid(lngGridCount) And arrPower(lngByteBitCount))
      lngGridCount = lngGridCount + 1&
    Next
  Next

  '***  convert the byte array to text
  fcnGetGridText = StrConv(arrMessage, vbUnicode)
End Function


Function fcnGetNextBit(lngBitCount As Long) As Boolean
  '***  used to loop through the array
  '***  (slow - remove)

  fcnGetNextBit = arrGrid(lngBitCount)
  lngBitCount = lngBitCount + 1&
End Function

Sub subAddToMessageGrid(lngColor As Long, _
  lngBits As Long, _
  blnRed As Boolean, _
  blnGreen As Boolean, _
  blnBlue As Boolean, _
  lngTrailingBits As Long, _
  lngBitCount As Long)

  '***  adds the bits from one single pixel to the message array
  '***  eg pixel is 3 bytes=24 bits (3 colors)
  '***  it gets the configured no of bit(s) from the used color(s)
  '***  arrGrid is used to store the message bits

  Dim lngColorCount As Long
  Dim lngCount As Long
  Dim arrDoCol(0 To 2) As Boolean

  arrDoCol(2) = blnRed
  arrDoCol(1) = blnGreen
  arrDoCol(0) = blnBlue

  For lngColorCount = 0& To 16& Step 8&
    If arrDoCol(lngColorCount \ 8&) Then
      For lngCount = lngColorCount To lngColorCount + lngBits
        arrGrid(lngBitCount) = lngColor And arrPower(lngCount)
        lngBitCount = lngBitCount + 1&
      Next
    End If
  Next

End Sub

Sub subHideMessage(txtMessage As String, _
  picSource As PictureBox, _
  picDestination As PictureBox, _
  lngBits As Long, _
  blnRed As Boolean, _
  blnGreen As Boolean, _
  blnBlue As Boolean, _
  lngTrailingBits As Long)

  '***  This is the main function for hiding data
  '***  It calls subInitMessageGrid to store the message in
  '***  the required format and it paints the new picture.

  On Error GoTo ERROR_subHideMessage

  picSource.ScaleMode = vbPixels
  picDestination.ScaleMode = vbPixels

  '***  Build the message array
  subInitMessageGrid txtMessage, picSource.ScaleWidth, picSource.ScaleHeight, lngBits, blnRed, blnGreen, blnBlue, lngTrailingBits

  Dim lngX As Long
  Dim lngY As Long
  Dim lngWidth As Long
  Dim lngHeight As Long
  Dim lngBitCount As Long

  '***  This loop paints the picture including the message

  With picSource
    lngWidth = .ScaleWidth - 1&
    lngHeight = .ScaleHeight - 1&
    lngBitCount = 0&
    For lngX = 0& To lngWidth
      For lngY = 0& To lngHeight
        picDestination.PSet (lngX, lngY), fcnGetChangedColor(.Point(lngX, lngY), lngBits, blnRed, blnGreen, blnBlue, lngBitCount)
      Next
    Next
  End With

EXIT_subHideMessage:
  Exit Sub

ERROR_subHideMessage:
  Select Case MsgBox("Error " & Err.Number & ": " & Err.Description & vbCrLf & "in subHideMessage" & vbCrLf & "The error occured at line: " & Erl, vbAbortRetryIgnore + vbCritical, "Error")
    Case vbAbort
      Screen.MousePointer = vbDefault
      Resume EXIT_subHideMessage
    Case vbRetry
      Resume
    Case vbIgnore
      Resume Next
  End Select

  Resume EXIT_subHideMessage

End Sub

Sub subInitMessageGrid(strMessage As String, _
  lngWidth As Long, _
  lngHeight As Long, _
  lngBits As Long, _
  blnRed As Boolean, _
  blnGreen As Boolean, _
  blnBlue As Boolean, _
  lngTrailingBits As Long)

  '***  this sub fills the arrGrid Array
  '***  the array is like a bit stream
  '***  it's size is based on the size of the picture and
  '***  the number of bits used for the message

  Dim lngColorsUsed As Long
  Dim lngBitsNeeded As Long
  Dim lngBitsAvailable As Long
  Dim arrMessage() As Byte
  Dim lngByteCount As Long
  Dim lngByteBitCount As Long
  Dim lngGridCount As Long
  Dim lngCount As Long
  Dim lngBitCount As Long

  '***  fill an array to store powers of 2
  ReDim arrPower(0& To 30&) As Long
  For lngCount = 0& To 30&
    arrPower(lngCount) = 2& ^ lngCount
  Next

  '***  check message lenght
  lngColorsUsed = Abs(blnRed + blnGreen + blnBlue)
  lngBitsNeeded = Len(strMessage) * 8&
  lngBitsAvailable = (lngWidth) * (lngHeight) * lngColorsUsed * (lngBits + 1&)

  '***  If the code breaks here, your message is too long,
  '***  or your picture is too small
  If lngBitsNeeded >= lngBitsAvailable Then
    MsgBox "The message is too long to fit in this picture. Use more bits and colors or use a bigger picture to hide this message."
    Exit Sub
  End If
  Debug.Assert lngBitsNeeded <= lngBitsAvailable

  ReDim arrGrid(0 To lngBitsAvailable)
  lngBitCount = 0&
  arrMessage = StrConv(strMessage, vbFromUnicode)

  '***  fill the array
  '***  if the message is shorter than the array
  '***  the remaining bits are zero.
  '***  (this should be changed)

  For lngByteCount = 0& To UBound(arrMessage, 1&)
    For lngByteBitCount = 0& To 7&
      arrGrid(lngGridCount) = arrMessage(lngByteCount) And arrPower(lngByteBitCount)
      lngGridCount = lngGridCount + 1&
    Next
  Next

End Sub

